# Token in pest - Rust
A token generated by a `Parser`.
Keywords: rust, rustlang, rust-lang, Token

# Enum pest::Token

source · [−]

    pub enum Token<'i, R> {
        Start {
            rule: R,
            pos: Position<'i>,
        },
        End {
            rule: R,
            pos: Position<'i>,
        },
    }

Expand description

A token generated by a `Parser`.

## Variants

### `Start`

#### Fields

`rule: R`

matched rule

`pos: Position<'i>`

starting position

The starting `Position` of a matched `Rule`

### `End`

#### Fields

`rule: R`

matched rule

`pos: Position<'i>`

ending position

The ending `Position` of a matched `Rule`

## Trait Implementations

source

### impl<'i, R: Clone> Clone for Token<'i, R>

source

#### fn clone(&self) -> Token<'i, R>

Returns a copy of the value. Read more

1.0.0 · source

#### fn clone_from(&mut self, source: &Self)

Performs copy-assignment from `source`. Read more

source

### impl<'i, R: Debug> Debug for Token<'i, R>

source

#### fn fmt(&self, f: &mut Formatter<'_>) -> Result

Formats the value using the given formatter. Read more

source

### impl<'i, R: Hash> Hash for Token<'i, R>

source

#### fn hash<__H: Hasher>(&self, state: &mut __H)

Feeds this value into the given `Hasher`. Read more

1.3.0 · source

#### fn hash_slice<H>(data: &[Self], state: &mut H) where
H: Hasher,

Feeds a slice of this type into the given `Hasher`. Read more

source

### impl<'i, R: PartialEq> PartialEq<Token<'i, R>> for Token<'i, R>

source

#### fn eq(&self, other: &Token<'i, R>) -> bool

This method tests for `self` and `other` values to be equal, and is used by `==`. Read more

source

#### fn ne(&self, other: &Token<'i, R>) -> bool

This method tests for `!=`.

source

### impl<'i, R: Eq> Eq for Token<'i, R>

source

### impl<'i, R> StructuralEq for Token<'i, R>

source

### impl<'i, R> StructuralPartialEq for Token<'i, R>

## Auto Trait Implementations

### impl<'i, R> RefUnwindSafe for Token<'i, R> where
R: RefUnwindSafe,

### impl<'i, R> Send for Token<'i, R> where
R: Send,

### impl<'i, R> Sync for Token<'i, R> where
R: Sync,

### impl<'i, R> Unpin for Token<'i, R> where
R: Unpin,

### impl<'i, R> UnwindSafe for Token<'i, R> where
R: UnwindSafe,

## Blanket Implementations

source

### impl<T> Any for T where
T: 'static + ?Sized,

source

#### fn type_id(&self) -> TypeId

Gets the `TypeId` of `self`. Read more

source

### impl<T> Borrow<T> for T where
T: ?Sized,

const: unstable · source

#### fn borrow(&self) -> &T

Immutably borrows from an owned value. Read more

source

### impl<T> BorrowMut<T> for T where
T: ?Sized,

const: unstable · source

#### fn borrow_mut(&mut self) -> &mut T

Mutably borrows from an owned value. Read more

source

### impl<T> From<T> for T

const: unstable · source

#### fn from(t: T) -> T

Returns the argument unchanged.

source

### impl<T, U> Into<U> for T where
U: From<T>,

const: unstable · source

#### fn into(self) -> U

Calls `U::from(self)`.

That is, this conversion is whatever the implementation of `From<T> for U` chooses to do.

source

### impl<T> ToOwned for T where
T: Clone,

#### type Owned = T

The resulting type after obtaining ownership.

source

#### fn to_owned(&self) -> T

Creates owned data from borrowed data, usually by cloning. Read more

source

#### fn clone_into(&self, target: &mut T)

Uses borrowed data to replace owned data, usually by cloning. Read more

source

### impl<T, U> TryFrom<U> for T where
U: Into<T>,

#### type Error = Infallible

The type returned in the event of a conversion error.

const: unstable · source

#### fn try_from(value: U) -> Result<T, <T as TryFrom<U>>::Error>

Performs the conversion.

source

### impl<T, U> TryInto<U> for T where
U: TryFrom<T>,

#### type Error = <U as TryFrom<T>>::Error

The type returned in the event of a conversion error.

const: unstable · source

#### fn try_into(self) -> Result<U, <U as TryFrom<T>>::Error>

Performs the conversion.